#define CPPTESK_ITERATION_SHORT_SHORT_NAMES
#define CPPTESK_ITERATION__LOCAL_VARS_IN_ACTION
#include "account_scen.h"
#include <tracer/tracer.hpp>

using namespace cpptesk::ts;

#define DEPOSIT_LIMIT 5


bool AccountScenario::init(int argc, char ** argv)
{
    return true;
}

void AccountScenario::finish() {}

//bool AccountScenario::deposit_scenario(IntCtx& ctx)
//{
////    if (mediator.balance == 0)
//    {
//        std::cout<< "DEBUG: scen: deposit: before IBEGIN: balance " << mediator.balance
//            << ", variable " << IVAR(i)
//            << ", mode " << ctx.__mode << std::endl;
//    }
////    IBEGIN
////    for (IVAR(i) = 1; IVAR(i) + mediator.balance <= limit; ++ IVAR(i))
//    IBEGIN_IF(mediator.balance < 5)
//    for (IVAR(i) = 1; IVAR(i) < 5; ++ IVAR(i))
//    {
////        if (mediator.balance == 0)
//        {
//            std::cout<< "DEBUG: scen: deposit: before IACTION: balance " << mediator.balance
//                << ", variable " << IVAR(i)
//                << ", mode " << ctx.__mode << std::endl;
//        }
//        IACTION
//        {
//            int val = IVAR(i);
////            if (mediator.balance == 0)
//            {
//                std::cout<< "DEBUG: scen: deposit: inside IACTION: balance " << mediator.balance
//                    << ", variable " << IVAR(i)
//                    << ", mode " << ctx.__mode << std::endl;
//            }
//            int sum = mediator.deposit(val);
////            YIELD (sum > 0 && sum <= val);
//            return (sum > 0 && sum <= val);
//        }
////        if (mediator.balance == 0)
//        {
//            std::cout<< "DEBUG: scen: deposit: after IACTION: balance " << mediator.balance
//                << ", variable " << IVAR(i)
//                << ", mode " << ctx.__mode << std::endl;
//        }
//        IACTION
//        {
//            std::cout << "DEBUG: scen: deposit: IACTION 2: balance " << mediator.balance
//                << ", variable " << IVAR(i)
//                << ", mode " << ctx.__mode << std::endl;
//            return true;
//        }
//    }
////    if (mediator.balance == 0)
//    {
//        std::cout<< "DEBUG: scen: deposit: before IEND: balance " << mediator.balance
//            << ", variable " << IVAR(i)
//            << ", mode " << ctx.__mode << std::endl;
//    }
//    IEND
//}


// Сценарный метод проверяет следующие фичи:
//   IBEGIN_IF -- условное ограничение итерации.
//   наличие двух блоков IACTION, перебор этих блоков без циклов
//   IACTION_IF -- условное выполнение блоков.
bool AccountScenario::deposit_scenario(IntCtx& ctx)
{
    int& val = IVAR(i);
    {
        std::cout<< "DEBUG: scen: deposit: before IBEGIN: balance " << mediator.balance
            << ", variable " << val
            << ", mode " << ctx.__mode << std::endl;
    }
    IBEGIN_IF(mediator.balance < DEPOSIT_LIMIT)
    {
        val = 1;
        IACTION_IF(mediator.balance % 2)
        {
            {
                std::cout<< "DEBUG: scen: deposit: inside IACTION 1: balance " << mediator.balance
                    << ", variable " << val
                    << ", mode " << ctx.__mode << std::endl;
            }
            int sum = mediator.deposit(val);
            return (sum > 0 && sum <= val);
        }
        {
            std::cout<< "DEBUG: scen: deposit: before IACTION 2: balance " << mediator.balance
                << ", variable " << val
                << ", mode " << ctx.__mode << std::endl;
            ++val;
        }
        IACTION
        {
            {
                std::cout<< "DEBUG: scen: deposit: inside IACTION 2: balance " << mediator.balance
                    << ", variable " << val
                    << ", mode " << ctx.__mode << std::endl;
            }
            int sum = mediator.deposit(val);
            return (sum > 0 && sum <= val);
        }
        {
            std::cout<< "DEBUG: scen: deposit: after IACTION 2: balance " << mediator.balance
                << ", variable " << val
                << ", mode " << ctx.__mode << std::endl;
            ++val;
        }
        {
            std::cout<< "DEBUG: scen: deposit: before IEND: balance " << mediator.balance
                << ", variable " << IVAR(i)
                << ", mode " << ctx.__mode << std::endl;
        }
    }
    IEND
}

bool AccountScenario::withdraw_scenario(IntCtx& ctx)
{
    int& val = IVAR(i);

    IBEGIN_IF(mediator.balance > 0)
    for (val = 1; val <= DEPOSIT_LIMIT + limit+1; ++ val)
    {
        IACTION_IF(mediator.balance - val >= -limit)
        {
            int sum = mediator.withdraw(val);
            return (sum >= 0 && sum <= val);
        }
    }
    IEND
}

// Сценарный метод используется при тестировании NDFSM
bool AccountScenarioEx::random_withdraw_scenario(IntCtx& ctx)
{
    IBEGIN
    IACTION
    {
        int value = rand() % limit;
        mediator.withdraw(value);
        YIELD(true);
    }
    IEND
}

AccountScenario::AccountScenario(int limit, Account* impl) : ScenarioBase(), mediator(impl), limit(limit)
{
    setup("Account Test");
    CPPTESK_ADD_SCENARIO_METHOD(AccountScenario::deposit_scenario);
    CPPTESK_ADD_SCENARIO_METHOD(AccountScenario::withdraw_scenario);
}
AccountScenario::AccountScenario(void) : ScenarioBase()
{
    setup("Account Test");
    CPPTESK_ADD_SCENARIO_METHOD(AccountScenario::deposit_scenario);
    CPPTESK_ADD_SCENARIO_METHOD(AccountScenario::withdraw_scenario);
}
AccountScenario::~AccountScenario(void) {}

AccountScenarioEx::AccountScenarioEx(int limit, Account* impl) : AccountScenario(limit, impl)
{
    setup("Account Test"
          , UseVirtual::init, NoMethod::finish, &AccountScenarioEx::get_state_int
        );
#ifdef NDFSM
    CPPTESK_ADD_SCENARIO_METHOD(AccountScenarioEx::random_withdraw_scenario);
#endif
}

bool AccountScenarioEx::get_state_scen()
{
    std::cout << "AccountScenario::get_state_scen: balance " << mediator.get_balance()<< std::endl;
    return mediator.get_balance();
}

int AccountScenarioEx::get_state_int()
{
    std::cout << "Current state: " << mediator.balance << std::endl;
    return mediator.balance;
}
