/*
 * Copyright 2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*/

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Mikhail Chupilko (chupilko@ispras.ru)
// SYNOPSIS: Additional function for priority arbiter
///////////////////////////////////////////////////////////////////////////////

#include <hw/arbiter/priority.hpp>
#include <hw/process/process.hpp>

namespace cpptesk {
namespace hw {

bool greater_request_priority(const ArbiterRequest &lhs, const ArbiterRequest &rhs)
{
    unsigned lp = lhs.process->get_priority();
    unsigned rp = rhs.process->get_priority();

    // PIDs are used to sort equivalent processes in order of increasing PIDs.
    return lp > rp || (lp == rp && lhs.process->get_pid() < rhs.process->get_pid());
}

}}

