/*Copyright 2010-2012 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Protsenko (protsenko@ispras.ru)
// SYNOPSIS: Rule # 2 in C++TESK.ErrorDiagnostics.ru.doc: {[o,o] -> [x,x]}  
//           Use for normal reactions
///////////////////////////////////////////////////////////////////////////////

#include <hw/diagnostics/rule/correct.hpp>

namespace cpptesk {
namespace hw {
namespace diagnostics {

ReactionSet CorrectReactionEliminationRule::transform(
                      ::cpptesk::hw::diagnostics::ReactionUnit &reaction_unit_1,
                      ::cpptesk::hw::diagnostics::ReactionUnit &reaction_unit_2)
{
    ReactionSet transform_out;

    CPPTESK_UNUSED_ARG(reaction_unit_2);
    reaction_unit_1.setCollapsed();

    return transform_out;
}

int CorrectReactionEliminationRule::match(::cpptesk::hw::Reaction reaction_1,
                                          ::cpptesk::hw::Reaction reaction_2)
{
    int match = FALSE_MATCH;
    CPPTESK_UNUSED_ARG(reaction_2);

    if(reaction_1.getError() == NORMAL_REACTION)
    {
        match = EXACT_MATCH;
    }

    return match;
}

}}}
