/*Copyright 2010-2012 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Protsenko (protsenko@ispras.ru)
// SYNOPSIS: virtual class
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include <hw/diagnostics/transform_unit.hpp>
#include <hw/diagnostics/reaction_unit.hpp>
#include <hw/diagnostics/reaction_set.hpp>

namespace cpptesk {
namespace hw {
namespace diagnostics {

class Rule
{
    public:
    const static int FALSE_MATCH = 10000; // more then fuzzy rule
    const static int FUZZY_MATCH = 1000; // more then normal rule
    const static int EXACT_MATCH = 0;

    const static int EMPTY_RULE = -1;

    Rule() {}
    virtual ~Rule() {}

    virtual ReactionSet transform(::cpptesk::hw::diagnostics::ReactionUnit &reaction_unit_1, 
                                  ::cpptesk::hw::diagnostics::ReactionUnit &reaction_unit_2)
    // Collapse the reactions
    {
        CPPTESK_UNUSED_ARG(reaction_unit_1);
        CPPTESK_UNUSED_ARG(reaction_unit_2);
        ReactionSet rs;
        return rs;
    }

    virtual int match(::cpptesk::hw::Reaction reaction_1, ::cpptesk::hw::Reaction reaction_2)
    // Compare the reactions
    {
        CPPTESK_UNUSED_ARG(reaction_1);
        CPPTESK_UNUSED_ARG(reaction_2);
        return EMPTY_RULE;
    }

    virtual void weight()
    // Get the weight of operation
    {
    }

    virtual void distance()
    //  
    {
    }

    virtual void setCollapseRule(::cpptesk::hw::diagnostics::ReactionUnit &reaction_unit_1, 
                         ::cpptesk::hw::diagnostics::ReactionUnit &reaction_unit_2, 
                         int rule, int rule_type)
    {
        CPPTESK_UNUSED_ARG(reaction_unit_1);
        CPPTESK_UNUSED_ARG(reaction_unit_2);
        CPPTESK_UNUSED_ARG(rule);
        CPPTESK_UNUSED_ARG(rule_type);
    }

    virtual std::string getRuleDescription()
    {
        return "Empty";
    }
};

}}}
